ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   platform = osx
else ifneq ($(findstring win,$(shell uname -a)),)
   platform = win
endif
endif

CFLAGS += -D_FILE_OFFSET_BITS=64

ifeq ($(platform), unix)
   TARGET_STATIC_LIB := liblinelet.a
   TARGET_SHARED_LIB := liblinelet.so.0.0
   TARGET_SHARED_LIB_SONAME = liblinelet.so.0
   TARGET_SHARED_LIB_LINK = liblinelet.so
   FPIC := -fPIC
   SHARED := -shared -Wl,-soname,$(TARGET_SHARED_LIB_SONAME)
   ASM_PREFIX := elf
   CFLAGS += -DHAVE_MMAP
else ifeq ($(platform), osx)
   TARGET_STATIC_LIB := liblinelet.a
   TARGET_SHARED_LIB := liblinelet.dylib
   FPIC := -fPIC
   SHARED := -dynamiclib
   ASM_PREFIX := macho
   CFLAGS += -DHAVE_MMAP
else ifeq ($(platform), win)
   CC = $(HOST_PREFIX)gcc
   AR = $(HOST_PREFIX)ar
   TARGET_STATIC_LIB := liblinelet.a
   TARGET_SHARED_LIB := linelet-0.dll
   TARGET_SHARED_IMPLIB := liblinelet.dll.a
   SHARED := -shared -Wl,--out-implib=$(TARGET_SHARED_IMPLIB)
   EXE_SUFFIX := .exe
   ASM_PREFIX := win
   LDFLAGS += -lws2_32
endif

YASM = yasm

MACHINE = $(shell $(CC) -dumpmachine)
ifeq ($(findstring x86_64,$(MACHINE)),x86_64)
   ASMFLAGS += -DARCH_X86_64=1
   BITS := 64
   SIMD := x86
   CFLAGS += -DLINELET_SIMD_X86
else ifeq ($(findstring i686,$(MACHINE)),i686)
   SIMD := x86
   ASMFLAGS += -DARCH_X86_64=0
   BITS := 32
   CFLAGS += -DLINELET_SIMD_X86
   ifeq ($(platform), win)
      ASMFLAGS += -DPREFIX=_
   endif
endif

ASMFLAGS += -DHIGH_BIT_DEPTH=1 -DBIT_DEPTH=8
ASMFLAGS += -f $(ASM_PREFIX)$(BITS)

PREFIX = /usr/local

