#ifndef LEGALL_H__
#define LEGALL_H__

#include <stdint.h>
#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

void linelet_legall_dwt_forward(int16_t * restrict out_lo, int16_t * restrict out_hi, const int16_t * restrict in, unsigned samples);
void linelet_legall_dwt_inverse(int16_t * restrict out, const int16_t * restrict in_lo, const int16_t * restrict in_hi, unsigned samples);

void linelet_legall_vert_dwt_forward_top(
      int16_t * restrict lp0,
      int16_t * restrict hp0,
      int16_t * restrict lp1,
      unsigned samples);

void linelet_legall_vert_dwt_forward(
      int16_t * restrict hp0,
      int16_t * restrict lp1,
      int16_t * restrict hp1,
      int16_t * restrict lp2,
      unsigned samples);

void linelet_legall_vert_dwt_forward_bottom(
      int16_t * restrict hp0,
      int16_t * restrict lp1,
      int16_t * restrict hp1,
      unsigned samples);

void linelet_legall_vert_dwt_inverse_top(
      int16_t * restrict lp0,
      int16_t * restrict hp0,
      unsigned samples);

void linelet_legall_vert_dwt_inverse(
      int16_t * restrict lp0,
      int16_t * restrict hp0,
      int16_t * restrict lp1,
      int16_t * restrict hp1,
      unsigned samples);

void linelet_legall_vert_dwt_inverse_bottom(
      int16_t * restrict lp0,
      int16_t * restrict hp0,
      unsigned samples);

#ifdef __cplusplus
}
#endif

#endif

