%include "inc/x86inc.asm"
%include "inc/x86util.asm"

%macro HAAR_LINE_FORWARD 0
; void haar_line_forward(int16_t *a, int16_t *b, unsigned samples)
cglobal haar_line_forward, 3, 3, 7
   sub r1, r0
   pcmpeqw m6, m6
   psrlw m6, 15 ; +1

.loop:
   mova m0, [r0]
   mova m1, [r0 + r1]
   mova m2, [r0 + mmsize]
   mova m3, [r0 + r1 + mmsize]

   psubw m1, m0
   psubw m3, m2

   mova m4, m1
   mova m5, m3
   paddw m4, m6
   paddw m5, m6
   psraw m4, 1 
   psraw m5, 1 
   paddw m0, m4
   paddw m2, m5

   mova [r0], m0
   mova [r0 + r1], m1
   mova [r0 + mmsize], m2
   mova [r0 + r1 + mmsize], m3

   add r0, mmsize * 2
   sub r2d, mmsize
   jg .loop
   
   RET
%endmacro

%macro HAAR_LINE_INVERSE 0
; void haar_line_inverse(int16_t *a, int16_t *b, unsigned samples)
cglobal haar_line_inverse, 3, 3, 7
   sub r1, r0
   pcmpeqw m6, m6
   psrlw m6, 15 ; +1

.loop:
   mova m0, [r0]
   mova m1, [r0 + r1]
   mova m2, [r0 + mmsize]
   mova m3, [r0 + r1 + mmsize]

   mova m4, m1
   mova m5, m3
   paddw m4, m6
   paddw m5, m6
   psraw m4, 1 
   psraw m5, 1 
   psubw m0, m4
   psubw m2, m5
   paddw m1, m0
   paddw m3, m2

   mova [r0], m0
   mova [r0 + r1], m1
   mova [r0 + mmsize], m2
   mova [r0 + r1 + mmsize], m3

   add r0, mmsize * 2 
   sub r2d, mmsize

   jg .loop
   
   RET
%endmacro

INIT_XMM sse2
HAAR_LINE_FORWARD
HAAR_LINE_INVERSE
INIT_MMX mmx2
HAAR_LINE_FORWARD
HAAR_LINE_INVERSE

