%include "inc/x86inc.asm"
%include "inc/x86util.asm"

%macro QUANTIZE 0
; void quantize_line(int16_t *data, unsigned samples, unsigned quant, int16_t add)
cglobal quantize_line, 4, 4, 6
   movd m4, r3d
   SPLATW m4, m4
   movd m5, r2d

.loop:
   mova m0, [r0]
   mova m1, [r0 + mmsize]
   mova m2, [r0 + mmsize * 2]
   mova m3, [r0 + mmsize * 3]
   paddw m0, m4
   paddw m1, m4
   paddw m2, m4
   paddw m3, m4
   psraw m0, m5
   psraw m1, m5
   psraw m2, m5
   psraw m3, m5
   mova [r0], m0
   mova [r0 + mmsize], m1
   mova [r0 + mmsize * 2], m2
   mova [r0 + mmsize * 3], m3

   add r0, mmsize * 4
   sub r1d, mmsize * 2

   jg .loop
   
   RET
%endmacro

%macro DEQUANTIZE 0
; void dequantize_line(int16_t *data, unsigned samples, unsigned quant)
cglobal dequantize_line, 3, 3, 5
   movd m4, r2d

.loop:
   mova m0, [r0]
   mova m1, [r0 + mmsize]
   mova m2, [r0 + mmsize * 2]
   mova m3, [r0 + mmsize * 3]
   psllw m0, m4
   psllw m1, m4
   psllw m2, m4
   psllw m3, m4
   mova [r0], m0
   mova [r0 + mmsize], m1
   mova [r0 + mmsize * 2], m2
   mova [r0 + mmsize * 3], m3

   add r0, mmsize * 4
   sub r1d, mmsize * 2

   jg .loop
   
   RET
%endmacro

INIT_XMM sse2
QUANTIZE
DEQUANTIZE
INIT_MMX mmx2
QUANTIZE
DEQUANTIZE

