%include "inc/x86inc.asm"
%include "inc/x86util.asm"

%macro HMINMAXSW 1 ; m0, m1 = dest, m2/m3 temp regs, m4/m5 == (0xffff, 0x7fff)
; Horizontal signed min/max please? :3
%if cpuflag(sse4) && %1 == 1
   paddw m0, m5 ; Tweak range to make it positive. The applicable range of minimum register is [-0x7fff, 0].
   pxor m1, m4 ; m1 = -m1 - 1. maximum => minimum
   phminposuw m0, m0
   phminposuw m1, m1
   psubw m0, m5
   pxor m1, m4
%else
   PSHUFLW m2, m0, q3232
   PSHUFLW m3, m1, q3232
%if mmsize == 16
   pshufhw m2, m2, q3232
   pshufhw m3, m3, q3232
%endif
   pminsw m2, m0
   pmaxsw m3, m1
   PSHUFLW m0, m2, q1111
   PSHUFLW m1, m3, q1111
%if mmsize == 16
   pshufhw m0, m0, q1111
   pshufhw m1, m1, q1111
%endif
   pminsw m0, m2
   pmaxsw m1, m3
%if mmsize == 16 && %1 == 1
   movhlps m2, m0
   movhlps m3, m1
   pminsw m0, m2
   pmaxsw m1, m3
%endif
%endif
%endmacro

%macro INIT_HMINMAX 0
%if cpuflag(sse4)
   pcmpeqw m4, m4
   mova m5, m4
   psrlw m5, 1 ; 0x7fff
%endif
%endmacro

%macro RANGE_MIN_MAX_LINE_8 0
; void range_min_max_line_8(uint64_t *precincts, const int16_t *src, unsigned precincts, unsigned step)
cglobal range_min_max_line_8, 4, 5, 6

   INIT_HMINMAX

.loop:
   mov r4d, r3d
   pxor m0, m0
   pxor m1, m1

.innerloop:
   pminsw m0, [r1]
   pmaxsw m1, [r1]
   add r1, mmsize
   sub r4d, mmsize / 2
   jg .innerloop

   HMINMAXSW 1
   punpcklwd m0, m1
   movd [r0], m0

   add r0, 8
   dec r2d
   jg .loop
   
   RET
%endmacro

%macro RANGE_MIN_MAX_LINE_4 0
; void range_min_max_line_4(uint64_t *precincts, const int16_t *src, unsigned precincts) step == 4
cglobal range_min_max_line_4, 3, 3, 6
   sub r1, r0
   INIT_HMINMAX

.loop:
   mova m0, [r0 + r1]
   mova m1, m0

   HMINMAXSW 0
%if mmsize == 8
   punpcklwd m0, m1
   movd [r0], m0
%else
   mova m2, m0
   punpcklwd m0, m1
   punpckhwd m2, m1
   movd [r0], m0
   movd [r0 + 8], m2
%endif

   add r0, mmsize
   sub r2d, mmsize / 8
   jg .loop
   
   RET
%endmacro

INIT_XMM sse2
RANGE_MIN_MAX_LINE_8
RANGE_MIN_MAX_LINE_4
INIT_XMM sse4
RANGE_MIN_MAX_LINE_8 ; phminposuw doesn't help for 4px case.
INIT_MMX mmx2
RANGE_MIN_MAX_LINE_8
RANGE_MIN_MAX_LINE_4

