#include "tests.h"
#include "haar.h"

int haar_test(void)
{
   int16_t data[8][16] = {
      { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 },
      { -1, -2, -3, -4, -5, -6, -7, -8, -9, -10, -11, -12, -13, -14, -15, -16 },
      { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 },
      { -1, -2, -3, -4, -5, -6, -7, -8, -9, -10, -11, -12, -13, -14, -15, -16 },
      { -1, -2, -3, -4, -5, -6, -7, -8, -9, -10, -11, -12, -13, -14, -15, -16 },
      { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 },
      { -1, -2, -3, -4, -5, -6, -7, -8, -9, -10, -11, -12, -13, -14, -15, -16 },
      { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 },
   };

   int16_t data_ref[8][16];
   memcpy(data_ref, data, sizeof(data));

   int ret = -1;
   for (unsigned i = 0; i < 8; i += 2, ret--)
   {
      linelet_haar_dwt_forward(data[i + 0], data[i + 1], 16);
      linelet_haar_dwt_inverse(data[i + 0], data[i + 1], 16);
      if (memcmp(data_ref[i], data[i], 2 * sizeof(data[i])))
         return ret;
   }
   return 0;
}

