#include "tests.h"
#include "memory.h"
#include "log.h"
#include <stdint.h>
#include <string.h>

int prepostfilter_test(void)
{
   int16_t test[8][8] = {
      { 10, 50, 10, 10, 12, 19, 22, 45 },
      { 20, 50, 10, 0, 15, -2, -8, -11},
      { 30, 50, 50, 80, 17, 12, 14, 16 },
      { 40, 50, 50, 60, 1, 2, 6, 8 },
      { 50, 50, 50, 60, 1, 2, 6, 8 },
      { 60, 50, 50, 60, 1, 2, 6, 8 },
      { 70, 50, 50, 60, 1, 2, 6, 8 },
      { 80, 50, 50, 60, 1, 2, 6, 8 },
   };

   int16_t reference[8][8];
   memcpy(reference, test, sizeof(test));

   // 2-line
   linelet_prefilter_2(test[3], test[4], 8);

   for (unsigned i = 0; i < 8; i++)
   {
      linelet_log_printf(LINELET_LOG_DEBUG, "%3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d -> %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d\n",
         reference[0][i], reference[1][i], reference[2][i], reference[3][i],
         reference[4][i], reference[5][i], reference[6][i], reference[7][i],
         test[0][i], test[1][i], test[2][i], test[3][i],
         test[4][i], test[5][i], test[6][i], test[7][i]);
   }

   linelet_postfilter_2(test[3], test[4], 8);

   if (memcmp(test, reference, sizeof(test)) != 0)
      return -1;

   // 4-line
   linelet_prefilter_4(test[2], test[3], test[4], test[5], 8);

   for (unsigned i = 0; i < 8; i++)
   {
      linelet_log_printf(LINELET_LOG_DEBUG, "%3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d -> %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d\n",
         reference[0][i], reference[1][i], reference[2][i], reference[3][i],
         reference[4][i], reference[5][i], reference[6][i], reference[7][i],
         test[0][i], test[1][i], test[2][i], test[3][i],
         test[4][i], test[5][i], test[6][i], test[7][i]);
   }

   linelet_postfilter_4(test[2], test[3], test[4], test[5], 8);

   if (memcmp(test, reference, sizeof(test)) != 0)
      return -2;

   // 8-line
   linelet_prefilter_8(test[0], test[1], test[2], test[3], test[4], test[5], test[6], test[7], 8);

   for (unsigned i = 0; i < 8; i++)
   {
      linelet_log_printf(LINELET_LOG_DEBUG, "%3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d -> %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d\n",
         reference[0][i], reference[1][i], reference[2][i], reference[3][i],
         reference[4][i], reference[5][i], reference[6][i], reference[7][i],
         test[0][i], test[1][i], test[2][i], test[3][i],
         test[4][i], test[5][i], test[6][i], test[7][i]);
   }

   linelet_postfilter_8(test[0], test[1], test[2], test[3], test[4], test[5], test[6], test[7], 8);

   if (memcmp(test, reference, sizeof(test)) != 0)
      return -3;

   return 0;
}

